DEFAULT_DEFINITION = [
{'Category': u'Covalent Modification', 'Reaction': u'P+', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'phosphorylation', 'Reversibility': u'irreversible', 'ReactionType': u'P+', 'Comments': '', 'coProduct(s)': u'ADP', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'1.1.1', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'-{P}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'P-', 'ProductState[Component]': u'N/A', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'dephosphorylation', 'Reversibility': u'irreversible', 'ReactionType': u'P-', 'Comments': '', 'coProduct(s)': u'Pi', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'1.1.2', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'-{P}'}, 
{'Category': u'Covalent Modification', 'Reaction': u'AP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'Autophosphorylation', 'Reversibility': u'irreversible', 'ReactionType': u'AP', 'Comments': '', 'coProduct(s)': u'ADP', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'1.1.3', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'-{P}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'PT', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'Phosphotransfer', 'Reversibility': u'reversible', 'ReactionType': u'PT', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'1.1.4', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'-{P}', 'Directionality': u'bidirectional', 'SourceState[Component]': u'ComponentA', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'-{P}'}, 
{'Category': u'Covalent Modification', 'Reaction': u'GEF', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'Guanine Nucleotide Exchange', 'Reversibility': u'irreversible', 'ReactionType': u'GEF', 'Comments': u'*G-proteins are assumed to bind GDP in their "basic" state. Exchange to GTP is denoted with the additional -{Pi}, which constitute the difference between the nucleotides.', 'coProduct(s)': u'GDP', 'coSubstrate(s)': u'GTP', 'ReactionTypeID': u'1.2.1', 'Subclass': u'GTP/GDP hydrolysis/exchange', 'ProductState[Modification]': u'-{P}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.2, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'GAP', 'ProductState[Component]': u'N/A', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'GTPase Activation', 'Reversibility': u'irreversible', 'ReactionType': u'GAP', 'Comments': u'*G-proteins are assumed to bind GDP in their "basic" state. Exchange to GTP is denoted with the additional -{Pi}, which constitute the difference between the nucleotides.', 'coProduct(s)': u'Pi', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'1.2.2', 'Subclass': u'GTP/GDP hydrolysis/exchange', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 1.2, 'CategoryType': 1, 'SourceState[Modification]': u'-{P}'}, 
{'Category': u'Covalent Modification', 'Reaction': u'Ub+', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Ub', 'ReactionName': u'Ubiquitination', 'Reversibility': u'irreversible', 'ReactionType': u'Ub+', 'Comments': '', 'coProduct(s)': u'ADP, Pi', 'coSubstrate(s)': u'Ubiquitin, ATP', 'ReactionTypeID': u'1.3.1', 'Subclass': u'(De)Ubiquitination', 'ProductState[Modification]': u'-{Ub}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.3, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'Ub-', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Ub', 'ReactionName': u'Deubiquitination', 'Reversibility': u'irreversible', 'ReactionType': u'Ub+', 'Comments': '', 'coProduct(s)': u'Ubiquitin, ADP', 'coSubstrate(s)': u'ADP', 'ReactionTypeID': u'1.3.1', 'Subclass': u'(De)Ubiquitination', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 1.3, 'CategoryType': 1, 'SourceState[Modification]': u'-{Ub}'}, 
{'Category': u'Covalent Modification', 'Reaction': u'CUT', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Truncated', 'ReactionName': u'Proteolytic cleaveage', 'Reversibility': u'irreversible', 'ReactionType': u'CUT', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': 1.4, 'Subclass': u'Proteolytic processing', 'ProductState[Modification]': u'-{Truncated}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.4, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 

{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 

{'Category': u'Association', 'Reaction': u'ppi', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'protein-protein interaction', 'Reversibility': u'reversible', 'ReactionType': u'ppi', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'2.1.1', 'Subclass': u'ppi', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.1, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'ipi', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': u'intra-protein interaction', 'Reversibility': u'reversible', 'ReactionType': u'ipi', 'Comments': u'*Self interaction', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'2.1.2', 'Subclass': u'ipi', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.1, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'tet', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'tetramerisation', 'Reversibility': u'reversible', 'ReactionType': u'tet', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'2.1.3', 'Subclass': u'tet', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.1, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'i', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'interaction (non-proteins)', 'Reversibility': u'reversible', 'ReactionType': u'i', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': 2.2, 'Subclass': u'i', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.2, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'BIND', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Binding to DNA', 'Reversibility': u'reversible', 'ReactionType': u'BIND', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': 2.3, 'Subclass': u'BIND', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.3, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 

{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 

{'Category': u'Synthesis/Degradation', 'Reaction': u'TRSC', 'ProductState[Component]': u'ComponentB-mRNA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Transcription', 'Reversibility': u'irreversible', 'ReactionType': u'TRSC', 'Comments': '', 'coProduct(s)': u'?', 'coSubstrate(s)': u'NTP', 'ReactionTypeID': 3.1, 'Subclass': u'TRSC', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 3.1, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Synthesis/Degradation', 'Reaction': u'TRSL', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Translation', 'Reversibility': u'irreversible', 'ReactionType': u'TRSL', 'Comments': '', 'coProduct(s)': u'?', 'coSubstrate(s)': u'AA, ATP', 'ReactionTypeID': 3.2, 'Subclass': u'TRSL', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 3.2, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Synthesis/Degradation', 'Reaction': u'DEG', 'ProductState[Component]': u'N/A', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Degradation', 'Reversibility': u'irreversible', 'ReactionType': u'DEG', 'Comments': '', 'coProduct(s)': u'?', 'coSubstrate(s)': u'?', 'ReactionTypeID': 3.3, 'Subclass': u'DEG', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 3.3, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Synthesis/Degradation', 'Reaction': u'CONSUME', 'ProductState[Component]': u'N/A', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Consumption', 'Reversibility': u'irreversible', 'ReactionType': u'CONSUME', 'Comments': '', 'coProduct(s)': u'?', 'coSubstrate(s)': u'?', 'ReactionTypeID': 3.4, 'Subclass': u'CONSUME', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 3.4, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Synthesis/Degradation', 'Reaction': u'PRODUCE', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Production', 'Reversibility': u'irreversible', 'ReactionType': u'PRODUCE', 'Comments': '', 'coProduct(s)': u'?', 'coSubstrate(s)': u'?', 'ReactionTypeID': 3.5, 'Subclass': u'PRODUCE', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 3.5, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 

{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 

{'Category': u'Relocalisation', 'Reaction': u'NIMP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Nucleus', 'ReactionName': u'Nuclear import', 'Reversibility': u'irreversible', 'ReactionType': u'NIMP', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.1', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Nucleus}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'NEXP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Nucleus, Cytoplasm', 'ReactionName': u'Nuclear export', 'Reversibility': u'irreversible', 'ReactionType': u'NEXP', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.2', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Nucleus}'}, 
{'Category': u'Relocalisation', 'Reaction': u'MIMP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial import', 'Reversibility': u'irreversible', 'ReactionType': u'MIMP', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.3', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Mitochondria}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'MEXP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Mitochondria, Cytoplasm', 'ReactionName': u'Mitochondrial export', 'Reversibility': u'irreversible', 'ReactionType': u'MEXP', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.4', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Mitochondria}'}, 
{'Category': u'Relocalisation', 'Reaction': u'TrnsCytExt', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Extracellular', 'ReactionName': u'Plasma membrane Cyt-\u02c3Ext ATPase pump', 'Reversibility': u'irreversible', 'ReactionType': u'TrnsCytExt', 'Comments': '', 'coProduct(s)': u'ADP, Pi', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'4.2.1', 'Subclass': u'Active transport', 'ProductState[Modification]': u'-{Extracellular}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.2, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'},
{'Category': u'Relocalisation', 'Reaction': u'TrnsCytVac', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar Cyt-\u02c3Vac ATPase pump', 'Reversibility': u'irreversible', 'ReactionType': u'TrnsCytVac', 'Comments': '', 'coProduct(s)': u'ADP, Pi', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'4.2.2', 'Subclass': u'Active transport', 'ProductState[Modification]': u'-{Vacuole}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.2, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'SymExtCyt', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': u'To be implemented', 'Modifier or Boundary': u'Extracellular, Cytoplasm', 'ReactionName': u'Plasma membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymExtCyt', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.1', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Extracellular}, -{Extracellular}'}, 
{'Category': u'Relocalisation', 'Reaction': u'SymCytVac', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': u'To be implemented', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymCytVac', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.2', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Vacuole}, -{Vacuole}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'SymCytMit', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': u'To be implemented', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymCytMit', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.3', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Mitochondria}, -{Mitochondria}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'SymCytEnd', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': u'To be implemented', 'Modifier or Boundary': u'Cytoplasm, Endosome', 'ReactionName': u'Endosomal membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymCytEnd', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.4', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Endosome}, -{Endosome}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'APExtCyt', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Extracellular, Cytoplasm', 'ReactionName': u'Plasma membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APExtCyt', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.1', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Cytoplasm}, -{Extracellular}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Extracellular}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'APCytVac', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APCytVac', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.2', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Vacuole}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Vacuole}'}, 
{'Category': u'Relocalisation', 'Reaction': u'APCytMit', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APCytMit', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.3', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Mitochondria}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Mitochondria}'}, 
{'Category': u'Relocalisation', 'Reaction': u'APCytEnd', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Endosome', 'ReactionName': u'Endosomal membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APCytEnd', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.4', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Endosome}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Endosome}'}, 
{'Category': u'Relocalisation', 'Reaction': u'FDExtCyt', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Extracellular, Cytoplasm', 'ReactionName': u'Plasma membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDExtCyt', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.1', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Extracellular}'}, 
{'Category': u'Relocalisation', 'Reaction': u'FDCytVac', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDCytVac', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.2', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Vacuole}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'FDCytMit', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDCytMit', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.3', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Mitochondria}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'FDCytEnd', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Endosome', 'ReactionName': u'Endosomal membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDCytEnd', 'Comments': '', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.4', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Endosome}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 


{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 
{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 
{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 
{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 
{'Category': '', 'Reaction': '', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 
{'Category': '', 'Reaction': u'Genetic evidence only (g_) or mapped from review paper (r_):', 'ProductState[Component]': '', 'F1': '', 'Modifier or Boundary': '', 'ReactionName': '', 'Reversibility': '', 'ReactionType': '', 'Comments': '', 'coProduct(s)': '', 'coSubstrate(s)': '', 'ReactionTypeID': '', 'Subclass': '', 'ProductState[Modification]': '', 'Directionality': '', 'SourceState[Component]': '', 'SubclassID': '', 'CategoryType': '', 'SourceState[Modification]': ''}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_P+', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'phosphorylation', 'Reversibility': u'irreversible', 'ReactionType': u'P+', 'Comments': 0, 'coProduct(s)': u'ADP', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'1.1.1', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'-{P}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_P-', 'ProductState[Component]': u'N/A', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'dephosphorylation', 'Reversibility': u'irreversible', 'ReactionType': u'P-', 'Comments': 0, 'coProduct(s)': u'Pi', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'1.1.2', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'-{P}'}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_AP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'Autophosphorylation', 'Reversibility': u'irreversible', 'ReactionType': u'AP', 'Comments': 0, 'coProduct(s)': u'ADP', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'1.1.3', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'-{P}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_PT', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'Phosphotransfer', 'Reversibility': u'reversible', 'ReactionType': u'PT', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'1.1.4', 'Subclass': u'(De)Phosphorylation', 'ProductState[Modification]': u'-{P}', 'Directionality': u'bidirectional', 'SourceState[Component]': u'ComponentA', 'SubclassID': 1.1, 'CategoryType': 1, 'SourceState[Modification]': u'-{P}'}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_GEF', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'Guanine Nucleotide Exchange', 'Reversibility': u'irreversible', 'ReactionType': u'GEF', 'Comments': u'*G-proteins are assumed to bind GDP in their "basic" state. Exchange to GTP is denoted with the additional -{Pi}, which constitute the difference between the nucleotides.', 'coProduct(s)': u'GDP', 'coSubstrate(s)': u'GTP', 'ReactionTypeID': u'1.2.1', 'Subclass': u'GTP/GDP hydrolysis/exchange', 'ProductState[Modification]': u'-{P}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.2, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_GAP', 'ProductState[Component]': u'N/A', 'F1': '', 'Modifier or Boundary': u'P', 'ReactionName': u'GTPase Activation', 'Reversibility': u'irreversible', 'ReactionType': u'GAP', 'Comments': u'*G-proteins are assumed to bind GDP in their "basic" state. Exchange to GTP is denoted with the additional -{Pi}, which constitute the difference between the nucleotides.', 'coProduct(s)': u'Pi', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'1.2.2', 'Subclass': u'GTP/GDP hydrolysis/exchange', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 1.2, 'CategoryType': 1, 'SourceState[Modification]': u'-{P}'}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_Ub+', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Ub', 'ReactionName': u'Ubiquitination', 'Reversibility': u'irreversible', 'ReactionType': u'Ub+', 'Comments': 0, 'coProduct(s)': u'ADP, Pi', 'coSubstrate(s)': u'Ubiquitin, ATP', 'ReactionTypeID': u'1.3.1', 'Subclass': u'(De)Ubiquitination', 'ProductState[Modification]': u'-{Ub}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.3, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Covalent Modification', 'Reaction': u'g_CUT', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Truncated', 'ReactionName': u'Proteolytic cleaveage', 'Reversibility': u'irreversible', 'ReactionType': u'CUT', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': 1.4, 'Subclass': u'Proteolytic processing', 'ProductState[Modification]': u'-{Truncated}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 1.4, 'CategoryType': 1, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'g_ppi', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'protein-protein interaction', 'Reversibility': u'reversible', 'ReactionType': u'ppi', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'2.1.1', 'Subclass': u'ppi', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.1, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'g_ipi', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': 0, 'ReactionName': u'intra-protein interaction', 'Reversibility': u'reversible', 'ReactionType': u'ipi', 'Comments': u'*Self interaction', 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'2.1.2', 'Subclass': u'ipi', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.1, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'g_i', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'interaction (non-proteins)', 'Reversibility': u'reversible', 'ReactionType': u'i', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': 2.2, 'Subclass': u'i', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.2, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Association', 'Reaction': u'g_BIND', 'ProductState[Component]': u'ComponentA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Binding to DNA', 'Reversibility': u'reversible', 'ReactionType': u'BIND', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': 2.3, 'Subclass': u'BIND', 'ProductState[Modification]': u'--ComponentB', 'Directionality': u'nondirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 2.3, 'CategoryType': 2, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Synthesis/Degradation', 'Reaction': u'g_TRSC', 'ProductState[Component]': u'ComponentB-mRNA', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Transcription', 'Reversibility': u'irreversible', 'ReactionType': u'TRSC', 'Comments': 0, 'coProduct(s)': u'?', 'coSubstrate(s)': u'NTP', 'ReactionTypeID': 3.1, 'Subclass': u'TRSC', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 3.1, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Synthesis/Degradation', 'Reaction': u'g_TRSL', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Translation', 'Reversibility': u'irreversible', 'ReactionType': u'TRSL', 'Comments': 0, 'coProduct(s)': u'?', 'coSubstrate(s)': u'AA, ATP', 'ReactionTypeID': 3.2, 'Subclass': u'TRSL', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'N/A', 'SubclassID': 3.2, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Synthesis/Degradation', 'Reaction': u'g_DEG', 'ProductState[Component]': u'N/A', 'F1': '', 'Modifier or Boundary': u'N/A', 'ReactionName': u'Degradation', 'Reversibility': u'irreversible', 'ReactionType': u'DEG', 'Comments': 0, 'coProduct(s)': u'?', 'coSubstrate(s)': u'?', 'ReactionTypeID': 3.3, 'Subclass': u'DEG', 'ProductState[Modification]': u'N/A', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 3.3, 'CategoryType': 3, 'SourceState[Modification]': u'N/A'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_NIMP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Nucleus', 'ReactionName': u'Nuclear import', 'Reversibility': u'irreversible', 'ReactionType': u'NIMP', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.1', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Nucleus}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_NEXP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Nucleus, Cytoplasm', 'ReactionName': u'Nuclear export', 'Reversibility': u'irreversible', 'ReactionType': u'NEXP', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.2', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Nucleus}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_MIMP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial import', 'Reversibility': u'irreversible', 'ReactionType': u'MIMP', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.3', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Mitochondria}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_MEXP', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Mitochondria, Cytoplasm', 'ReactionName': u'Mitochondrial export', 'Reversibility': u'irreversible', 'ReactionType': u'MEXP', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.1.4', 'Subclass': u'Protein Translocation', 'ProductState[Modification]': u'-{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.1, 'CategoryType': 4, 'SourceState[Modification]': u'-{Mitochondria}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_TrnsCytExt', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Extracellular', 'ReactionName': u'Plasma membrane Cyt-\u02c3Ext ATPase pump', 'Reversibility': u'irreversible', 'ReactionType': u'TrnsCytExt', 'Comments': 0, 'coProduct(s)': u'ADP, Pi', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'4.2.1', 'Subclass': u'Active transport', 'ProductState[Modification]': u'-{Extracellular}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.2, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_TrnsCytVac', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar Cyt-\u02c3Vac ATPase pump', 'Reversibility': u'irreversible', 'ReactionType': u'TrnsCytVac', 'Comments': 0, 'coProduct(s)': u'ADP, Pi', 'coSubstrate(s)': u'ATP', 'ReactionTypeID': u'4.2.2', 'Subclass': u'Active transport', 'ProductState[Modification]': u'-{Vacuole}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.2, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_SymExtCyt', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Extracellular, Cytoplasm', 'ReactionName': u'Plasma membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymExtCyt', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.1', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Extracellular}, -{Extracellular}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_SymCytVac', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymCytVac', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.2', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Vacuole}, -{Vacuole}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_SymCytMit', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymCytMit', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.3', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Mitochondria}, -{Mitochondria}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_SymCytEnd', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Endosome', 'ReactionName': u'Endosomal membrane symporter', 'Reversibility': u'reversible', 'ReactionType': u'SymCytEnd', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.3.4', 'Subclass': u'Symport', 'ProductState[Modification]': u'-{Endosome}, -{Endosome}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': 4.3, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_APExtCyt', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Extracellular, Cytoplasm', 'ReactionName': u'Plasma membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APExtCyt', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.1', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Cytoplasm}, -{Extracellular}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Extracellular}, -{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_APCytVac', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APCytVac', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.2', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Vacuole}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Vacuole}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_APCytMit', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APCytMit', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.3', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Mitochondria}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Mitochondria}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_APCytEnd', 'ProductState[Component]': u'ComponentB, ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Endosome', 'ReactionName': u'Endosomal membrane antiporter', 'Reversibility': u'irreversible', 'ReactionType': u'APCytEnd', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.4.4', 'Subclass': u'Antiport', 'ProductState[Modification]': u'-{Endosome}, -{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB, ComponentB', 'SubclassID': u'4,4', 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}, -{Endosome}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_FDExtCyt', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Extracellular, Cytoplasm', 'ReactionName': u'Plasma membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDExtCyt', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.1', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Cytoplasm}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Extracellular}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_FDCytVac', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Vacuole', 'ReactionName': u'Vacuolar membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDCytVac', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.2', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Vacuole}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_FDCytMit', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Mitochondria', 'ReactionName': u'Mitochondrial membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDCytMit', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.3', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Mitochondria}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}, 
{'Category': u'Relocalisation', 'Reaction': u'g_FDCytEnd', 'ProductState[Component]': u'ComponentB', 'F1': '', 'Modifier or Boundary': u'Cytoplasm, Endosome', 'ReactionName': u'Endosomal membrane channel', 'Reversibility': u'reversible', 'ReactionType': u'FDCytEnd', 'Comments': 0, 'coProduct(s)': u'N/A', 'coSubstrate(s)': u'N/A', 'ReactionTypeID': u'4.5.4', 'Subclass': u'Facilitated diffusion', 'ProductState[Modification]': u'-{Endosome}', 'Directionality': u'unidirectional', 'SourceState[Component]': u'ComponentB', 'SubclassID': 4.5, 'CategoryType': 4, 'SourceState[Modification]': u'-{Cytoplasm}'}
]